//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Boids
//    v:0.1 12/09/2002
//
//  This program implements Boids as a demonstration of emergent behaviour
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package boid;

import java.awt.*;
import java.awt.event.*;
import vabase.*;

/** Interface utilisateur des boids */
public class boidUI extends Cui {
  /** Les boids */
  Cboid Boids;

  /** Elments d'interface */
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel1 = new Panel();
  Button btnGo = new Button();
  Panel panelVue = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Button btnPas = new Button();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  GridLayout gridLayout3 = new GridLayout();
  Choice chCohesion = new Choice();
  Label label1 = new Label();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout4 = new GridLayout();
  Choice chEvite = new Choice();
  Choice chAligne = new Choice();
  Choice chPop = new Choice();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Choice chObjectif = new Choice();
  Choice chVent = new Choice();
  Label label5 = new Label();
  Label label6 = new Label();
  Button btnDisperse = new Button();
  Button btnNew = new Button();
  Label label7 = new Label();
  Label label8 = new Label();
  Choice chTempo = new Choice();
  Label label9 = new Label();

  /** Constructeur */
  public boidUI(boidLaunch am) {
    super((Claunch)am);
    Boids=new Cboid(this,Cboid.POP);
    process=(Cprocess)Boids;
    Boids.setTempo(10);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /** Initialisation */
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    btnGo.setLabel("Go");
    btnGo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnGo_actionPerformed(e);
      }
    });
    panelVue.setBackground(Color.red);
    panelVue.setLayout(gridLayout1);
    btnPas.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPas_actionPerformed(e);
      }
    });
    btnPas.setLabel("Pas");
    panel3.setLayout(gridLayout3);
    gridLayout3.setRows(2);
    label1.setAlignment(1);
    label1.setText("Cohsion");
    panel5.setLayout(gridLayout2);
    gridLayout2.setColumns(7);
    panel4.setLayout(gridLayout4);
    gridLayout4.setColumns(7);
    label2.setAlignment(1);
    label2.setText("Evitement");
    label3.setAlignment(1);
    label3.setText("Alignement");
    label4.setAlignment(1);
    label4.setText("Population");
    chCohesion.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chCohesion_itemStateChanged(e);
      }
    });
    chEvite.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chEvite_itemStateChanged(e);
      }
    });
    chAligne.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chAligne_itemStateChanged(e);
      }
    });
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    label5.setAlignment(1);
    label5.setText("Objectif");
    label6.setAlignment(1);
    label6.setText("Vent");
    chVent.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chVent_itemStateChanged(e);
      }
    });
    chObjectif.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chObjectif_itemStateChanged(e);
      }
    });
    btnDisperse.setEnabled(false);
    btnDisperse.setLabel("Disperse");
    btnDisperse.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnDisperse_actionPerformed(e);
      }
    });
    chPop.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chPop_itemStateChanged(e);
      }
    });
    btnNew.setLabel("Nouveau");
    btnNew.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnNew_actionPerformed(e);
      }
    });
    label7.setText("label7");
    label8.setAlignment(1);
    label8.setText("Tempo.");
    chTempo.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        chTempo_itemStateChanged(e);
      }
    });
    label9.setText("Cliquer pour positionner un objectif. Double clics le supprime.");
    this.add(panel1, BorderLayout.SOUTH);
    panel1.add(btnPas, null);
    panel1.add(btnGo, null);
    panel1.add(btnDisperse, null);
    panel1.add(btnNew, null);
    panel1.add(label9, null);
    this.add(panelVue, BorderLayout.CENTER);
    this.add(panel3,  BorderLayout.NORTH);
    panel3.add(panel5, null);
    panel5.add(label1, null);
    panel5.add(label2, null);
    panel5.add(label3, null);
    panel5.add(label5, null);
    panel5.add(label6, null);
    panel5.add(label4, null);
    panel5.add(label8, null);
    panel3.add(panel4, null);
    panel4.add(chCohesion, null);
    panel4.add(chEvite, null);
    panel4.add(chAligne, null);
    panel4.add(chObjectif, null);
    panel4.add(chVent, null);
    panel4.add(chPop, null);
    panel4.add(chTempo, null);
    // Elments des menus
    chCohesion.addItem("10");
    chCohesion.addItem("25");
    chCohesion.addItem("50");
    chCohesion.addItem("100");
    chCohesion.select(1);
    chEvite.addItem("5");
    chEvite.addItem("10");
    chEvite.addItem("20");
    chEvite.addItem("30");
    chEvite.addItem("50");
    chEvite.select(2);
    chAligne.addItem("2");
    chAligne.addItem("10");
    chAligne.addItem("25");
    chAligne.addItem("50");
    chAligne.addItem("100");
    chAligne.select(2);
    chObjectif.addItem("25");
    chObjectif.addItem("50");
    chObjectif.addItem("75");
    chObjectif.addItem("150");
    chObjectif.select(1);
    chVent.addItem("5");
    chVent.addItem("-5");
    chVent.addItem("10");
    chVent.addItem("-10");
    chVent.addItem("20");
    chVent.addItem("0");
    chPop.addItem("10");
    chPop.addItem("20");
    chPop.addItem("30");
    chPop.addItem("50");
    chPop.select(2);
    chTempo.addItem("1");
    chTempo.addItem("10");
    chTempo.addItem("25");
    chTempo.addItem("50");
    chTempo.addItem("100");
    chTempo.select(1);
    // Initialisation des paramtres
    Boids.setParam(Integer.parseInt(chCohesion.getSelectedItem()),
                    Integer.parseInt(chEvite.getSelectedItem()),
                    Integer.parseInt(chAligne.getSelectedItem()),
                    Integer.parseInt(chObjectif.getSelectedItem()),
                    Integer.parseInt(chVent.getSelectedItem()));
    // Ajout de la vue dans un panel
    panelVue.add(Boids.boidVue,null);
  }

  /** Go */
  void btnGo_actionPerformed(ActionEvent e) {
    stopGo();
  }
  /** Stop/Go */
  private void stopGo() {
    if(Boids.isRunning==false) {
      btnGo.setLabel("Stop");
      setInterface(false);
      Boids.lancement();
    }
    else {
      btnGo.setLabel("Go");
      Boids.stop();
      setInterface(true);
    }
  }
  void btnPas_actionPerformed(ActionEvent e) {
    Boids.geneSuiv();
  }
  /** Valeur de cohsion */
  void chCohesion_itemStateChanged(ItemEvent e) {
    Boids.setCohesion(Integer.parseInt(chCohesion.getSelectedItem()));
  }
  /** Valeur d'vitement */
  void chEvite_itemStateChanged(ItemEvent e) {
    Boids.setEvite(Integer.parseInt(chEvite.getSelectedItem()));
  }
  /** Valeur d'alignement */
  void chAligne_itemStateChanged(ItemEvent e) {
    Boids.setAligne(Integer.parseInt(chAligne.getSelectedItem()));
  }
  /** Valeur d'objectif */
  void chObjectif_itemStateChanged(ItemEvent e) {
    Boids.setObjectif(Integer.parseInt(chObjectif.getSelectedItem()));
  }
  /** Valeur du vent */
  void chVent_itemStateChanged(ItemEvent e) {
    Boids.setVent(Integer.parseInt(chVent.getSelectedItem()));
  }
  /** Change taille pop */
   void chPop_itemStateChanged(ItemEvent e) {
      Boids.setNewPop(Integer.parseInt(chPop.getSelectedItem()));
      Boids.initVue();
  }
  /** Change Tempo */
  void chTempo_itemStateChanged(ItemEvent e) {
      Boids.setTempo(Integer.parseInt(chTempo.getSelectedItem()));
  }

  /** Nouvelle pop */
  void btnNew_actionPerformed(ActionEvent e) {
    Boids.setNewPop(Integer.parseInt(chPop.getSelectedItem()));
    if(Boids.isRunning==true) {
      synchronized (Boids.prThread) { Boids.stop(); }
      Boids.initVue();
      Boids.lancement();
    }
    else
      Boids.initVue();
  }

  /** Redimensionnement de la fentre */
  void this_componentResized(ComponentEvent e) {
    redimUi();
  }

  /** Disperse les boids */
  void btnDisperse_actionPerformed(ActionEvent e) {
    if(!Boids.isRunning) return;
    Boids.disperse();
  }

  /** (in)activation interface */
  public void setInterface(boolean e) {
    btnPas.setEnabled(e);
    btnDisperse.setEnabled(!e);
    chPop.setEnabled(e);
  }
  /** Affichage gnration (inutile) */
  public void affGeneration() {
    ;
  }
}

